#
# Conditional build:
%bcond_without	static_libs	# static library
%bcond_with	tests		# build tests
%bcond_without	java		# JNI interface
%bcond_with	gimp		# build gimp plugin

%{?use_default_jdk}

Summary:	JPEG XL reference implementation
Summary(pl.UTF-8):	Referencyjna implementacja JPEG XL
Name:		libjxl
Version:	0.11.1
Release:	2
License:	BSD
Group:		Libraries
#Source0Download: https://github.com/libjxl/libjxl/releases
Source0:	https://github.com/libjxl/libjxl/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	8f26fc954c2d9cb377544a5f029182ef
Patch0:		%{name}-system-libs.patch
URL:		https://github.com/libjxl/libjxl
BuildRequires:	OpenEXR-devel
BuildRequires:	asciidoc
BuildRequires:	cmake >= 3.16
BuildRequires:	doxygen
BuildRequires:	gdk-pixbuf2-devel >= 2.38
BuildRequires:	giflib-devel >= 5
%{?with_gimp:BuildRequires:	gimp-devel >= 1:2.10}
%if %{with tests}
BuildRequires:	gmock-devel
BuildRequires:	google-benchmark-devel
BuildRequires:	gtest-devel
%endif
BuildRequires:	highway-devel >= 0.15.0
%{?with_java:%buildrequires_jdk}
%{?with_java:%{?use_jdk:BuildRequires:  %{use_jdk}-jre-base-X11}}
BuildRequires:	lcms2-devel >= 2.10
BuildRequires:	libavif-devel
BuildRequires:	libbrotli-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libwebp-devel
BuildRequires:	libstdc++-devel >= 6:7
BuildRequires:	lodepng-devel
BuildRequires:	pkgconfig
BuildRequires:	python3-devel >= 1:3
BuildRequires:	rpmbuild(macros) >= 2.021
BuildRequires:	zlib-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if "%{_lib}" != "lib"
%define		libext		%(lib="%{_lib}"; echo ${lib#lib})
%define		pqext		-%{libext}
%else
%define		pqext		%{nil}
%endif

%description
JPEG XL reference implementation.

%description -l pl.UTF-8
Referencyjna implementacja JPEG XL.

%package tools
Summary:	Tools to encode and decode JPEG XL files
Summary(pl.UTF-8):	Narzędzia do kodowania i dekodowania plików JPEG XL
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}

%description tools
Tools to encode and decode JPEG XL files.

%description tools -l pl.UTF-8
Narzędzia do kodowania i dekodowania plików JPEG XL.

%package devel
Summary:	Header files for JXL libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek JXL
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	highway-devel >= 0.15.0
Requires:	lcms2-devel >= 2.10
Requires:	libbrotli-devel
Requires:	libstdc++-devel >= 6:7

%description devel
Header files for JXL libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek JXL.

%package static
Summary:	Static JXL libraries
Summary(pl.UTF-8):	Statyczne biblioteki JXL
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static JXL libraries.

%description static -l pl.UTF-8
Statyczne biblioteki JXL.

%package -n java-libjxl
Summary:	JNI interface for JXL library
Summary(pl.UTF-8):	Interfejs JNI do biblioteki JXL
Group:		Libraries/Java
Requires:	%{name} = %{version}-%{release}

%description -n java-libjxl
JNI interface for JXL library.

%description -n java-libjxl -l pl.UTF-8
Interfejs JNI do biblioteki JXL.

%package -n gdk-pixbuf2-loader-jxl
Summary:	JPEG XL loader module for gdk-pixbuf2 library
Summary(pl.UTF-8):	Moduł biblioteki gdk-pixbuf2 wczytujący pliki JPEG XL
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	gdk-pixbuf2 >= 2.38
Requires:	shared-mime-info

%description -n gdk-pixbuf2-loader-jxl
JPEG XL loader module for gdk-pixbuf2 library.

%description -n gdk-pixbuf2-loader-jxl -l pl.UTF-8
Moduł biblioteki gdk-pixbuf2 wczytujący pliki JPEG XL.

%package -n gimp-plugin-jxl
Summary:	JPEG XL load/save plugin for GIMP
Summary(pl.UTF-8):	Wtyczka wczytująca/zapisująca pliki JPEG XL dla GIMP-a
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}
Requires:	gimp >= 1:2.10

%description -n gimp-plugin-jxl
JPEG XL load/save plugin for GIMP.

%description -n gimp-plugin-jxl -l pl.UTF-8
Wtyczka wczytująca/zapisująca pliki JPEG XL dla GIMP-a.

%prep
%setup -q
%patch -P0 -p1

%build
export JAVA_HOME="%{java_home}"

%if %{with static_libs}
%cmake -B build-static \
	-DBUILD_SHARED_LIBS=OFF \
	%{cmake_on_off tests BUILD_TESTING} \
	%{cmake_on_off gimp JPEGXL_ENABLE_PLUGIN_GIMP210} \
	-DJPEGXL_ENABLE_BENCHMARK=OFF \
	-DJPEGXL_ENABLE_DOXYGEN=OFF \
	-DJPEGXL_ENABLE_EXAMPLES=OFF \
	-DJPEGXL_ENABLE_JNI=OFF \
	-DJPEGXL_ENABLE_MANPAGES=OFF \
	-DJPEGXL_ENABLE_SJPEG=OFF \
	-DJPEGXL_ENABLE_SKCMS=OFF \
	-DJPEGXL_ENABLE_TCMALLOC=OFF \
	-DJPEGXL_ENABLE_TOOLS=OFF \
	-DJPEGXL_ENABLE_VIEWERS=OFF \
	-DJPEGXL_FORCE_SYSTEM_BROTLI=ON \
	-DJPEGXL_FORCE_SYSTEM_GTEST=ON \
	-DJPEGXL_FORCE_SYSTEM_HWY=ON \
	-DJPEGXL_FORCE_SYSTEM_LCMS2=ON \
	-DJPEGXL_INSTALL_JARDIR=%{_javadir}

%{__make} -C build-static
%endif

%cmake -B build \
	%{cmake_on_off tests BUILD_TESTING} \
	%{!?with_java:-DJPEGXL_ENABLE_JNI=OFF} \
	%{cmake_on_off gimp JPEGXL_ENABLE_PLUGIN_GIMP210} \
	-DJPEGXL_ENABLE_PLUGINS=ON \
	-DJPEGXL_ENABLE_SJPEG=OFF \
	-DJPEGXL_ENABLE_SKCMS=OFF \
	-DJPEGXL_ENABLE_TCMALLOC=OFF \
	-DJPEGXL_FORCE_SYSTEM_BROTLI=ON \
	-DJPEGXL_FORCE_SYSTEM_GTEST=ON \
	-DJPEGXL_FORCE_SYSTEM_HWY=ON \
	-DJPEGXL_FORCE_SYSTEM_LCMS2=ON \
	-DJPEGXL_INSTALL_JARDIR=%{_javadir}

%{__make} -C build

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
%{__make} -C build-static install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n gdk-pixbuf2-loader-jxl
umask 022
%{_bindir}/gdk-pixbuf-query-loaders%{pqext} --update-cache || :
%update_mime_database

%postun	-n gdk-pixbuf2-loader-jxl
%update_mime_database
if [ "$1" != "0" ]; then
	umask 022
	[ ! -x %{_bindir}/gdk-pixbuf-query-loaders%{pqext} ] || \
	%{_bindir}/gdk-pixbuf-query-loaders%{pqext} --update-cache || :
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGELOG.md CONTRIBUTORS LICENSE PATENTS README.md SECURITY.md doc/xl_overview.md
%attr(755,root,root) %{_libdir}/libjxl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjxl.so.0.11
%attr(755,root,root) %{_libdir}/libjxl_cms.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjxl_cms.so.0.11
%attr(755,root,root) %{_libdir}/libjxl_threads.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjxl_threads.so.0.11

%files tools
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/benchmark_xl
%attr(755,root,root) %{_bindir}/cjxl
%attr(755,root,root) %{_bindir}/djxl
%attr(755,root,root) %{_bindir}/jxlinfo
%{_mandir}/man1/cjxl.1*
%{_mandir}/man1/djxl.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjxl.so
%attr(755,root,root) %{_libdir}/libjxl_cms.so
%attr(755,root,root) %{_libdir}/libjxl_threads.so
%{_libdir}/libjxl_extras_codec.a
%{_includedir}/jxl
%{_pkgconfigdir}/libjxl.pc
%{_pkgconfigdir}/libjxl_cms.pc
%{_pkgconfigdir}/libjxl_threads.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libjxl.a
%{_libdir}/libjxl_cms.a
%{_libdir}/libjxl_threads.a
%endif

%if %{with java}
%files -n java-libjxl
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjxl_jni.so
%{_javadir}/org.jpeg.jpegxl.jar
%endif

%files -n gdk-pixbuf2-loader-jxl
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/gdk-pixbuf-2.0/2.10.0/loaders/libpixbufloader-jxl.so
%{_datadir}/mime/packages/image-jxl.xml
%{_datadir}/thumbnailers/jxl.thumbnailer

%if %{with gimp}
%files -n gimp-plugin-jxl
%defattr(644,root,root,755)
%dir %{_libdir}/gimp/2.0/plug-ins/file-jxl
%attr(755,root,root) %{_libdir}/gimp/2.0/plug-ins/file-jxl/file-jxl
%endif
%changelog
* Fri Mar 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libjxl.git;a=log;h=master

* Fri Mar 07 2025 Jakub Bogusz <qboosh@pld-linux.org> 2d2de2c
- release 2 (libavif 1.2.x)

* Thu Jan 30 2025 Jakub Bogusz <qboosh@pld-linux.org> 205fa79
- libjxl_extras_codec is static-only library now

* Wed Jan 29 2025 Jakub Bogusz <qboosh@pld-linux.org> c756954
- use patch -P

* Wed Jan 29 2025 Jan Rękorajski <baggins@pld-linux.org> 20c9eca
- up to 0.11.1
- disable gimp plugin, does not build for gimp 3

* Fri Apr 05 2024 Jakub Bogusz <qboosh@pld-linux.org> bcd5e5c
- updated to 0.10.2 (new sonames)

* Sun Aug 20 2023 Jan Palus <atler@pld-linux.org> 8360813
- up to 0.8.2

* Sun Aug 20 2023 Jan Palus <atler@pld-linux.org> b8a3d7d
- macros for %use_default_jdk

* Tue Mar 07 2023 Jan Palus <atler@pld-linux.org> c16b2e7
- BR: *-jre-base-X11 for java

* Tue Mar 07 2023 Jan Palus <atler@pld-linux.org> 667ba64
- switch to %{use_default_jdk}

* Mon Mar 06 2023 Jakub Bogusz <qboosh@pld-linux.org> 3d921d4
- updated to 0.8.1 (new sonames, added jni interface)
- removed outdated hwy, pc patches

* Sat Jul 09 2022 Jan Palus <atler@pld-linux.org> c6b04e9
- add tests bcond (keep disabled by default) and make test deps conditional

* Tue May 03 2022 Jakub Bogusz <qboosh@pld-linux.org> 00e45f8
- added pc patch (support absolute CMAKE_INSTALL_{INCLUDE,LIB}DIR in .pc files); release 2

* Sun Apr 10 2022 Jakub Bogusz <qboosh@pld-linux.org> 00662d4
- updated to 0.6.1
- updated system-libs patch
- added hwy patch (updates for highway 0.16.0 from git)

* Sun Apr 10 2022 Jan Rękorajski <baggins@pld-linux.org> 9c964b9
- BR google-benchmark-devel for jxl_gbench tool, rel 6

* Sat Apr 09 2022 Jan Rękorajski <baggins@pld-linux.org> 6d9a9da
- Release 5 (by relup.sh)

* Mon Feb 14 2022 Jan Rękorajski <baggins@pld-linux.org> 386a3e9
- Release 4 (by relup.sh)

* Mon Feb 14 2022 Jan Rękorajski <baggins@pld-linux.org> 53ed286
- added lodepng build dep

* Sat Feb 05 2022 Jan Rękorajski <baggins@pld-linux.org> 16f67f2
- Release 3 (by relup.sh)

* Fri Oct 22 2021 Jakub Bogusz <qboosh@pld-linux.org> 91d6304
- missing dir, release 2

* Tue Oct 05 2021 Jakub Bogusz <qboosh@pld-linux.org> fe1629d
- new; system libs patch to use system lcms2 (and possibly lodepng, sjpeg, skcms)

